# Mac OS PEF File

Assembler code

```
seg000:00002BDC
seg000:00002BDC # =============== S U B R O U T I N E =======================================
seg000:00002BDC
seg000:00002BDC # Attributes: noreturn
seg000:00002BDC
seg000:00002BDC                 .globl .start
seg000:00002BDC .start:                                 # DATA XREF: seg000:00003A60↓o
seg000:00002BDC                                         # seg001:start↓o
seg000:00002BDC
seg000:00002BDC .set sender_sp, -0x450
seg000:00002BDC .set saved_toc, -0x43C
seg000:00002BDC .set var_20, -0x20
seg000:00002BDC .set var_C, -0xC
seg000:00002BDC .set var_8, -8
seg000:00002BDC .set var_4, -4
seg000:00002BDC .set sender_lr,  8
seg000:00002BDC
seg000:00002BDC                 mflr      r0
seg000:00002BE0                 stw       r31, var_4(r1)
seg000:00002BE4                 stw       r30, var_8(r1)
seg000:00002BE8                 stw       r29, var_C(r1)
seg000:00002BEC                 stw       r0, sender_lr(r1)
seg000:00002BF0                 stwu      r1, sender_sp(r1)
seg000:00002BF4                 mr        r29, r3
seg000:00002BF8                 mr        r30, r4
seg000:00002BFC                 mr        r31, r5
seg000:00002C00                 lwz       r3, TC_argv_save # argv_save
seg000:00002C04                 cmplwi    r31, 0
seg000:00002C08                 lwz       r4, TC_environ # environ
seg000:00002C0C                 stw       r30, 0(r3)
seg000:00002C10                 stw       r31, 0(r4)
seg000:00002C14                 bne       loc_2C20
seg000:00002C18                 addi      r0, r2, (off_3E44 - 0x3A70) # "NO_ENVIRON=true"
seg000:00002C1C                 stw       r0, 0(r4)
seg000:00002C20
seg000:00002C20 loc_2C20:                               # CODE XREF: .start+38↑j
seg000:00002C20                 li        r3, 0
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hex-rays.com/core/disassembler/disassembly-gallery/mac-os-pef-file.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
